> For the complete documentation index, see [llms.txt](https://docs.bird.com/api/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.bird.com/api/reporting-api/api-reference/reports.md).

# Reports

## GET /organizations/{organizationId}/reports

> List organization reports

```json
{"openapi":"3.0.3","info":{"title":"Accounting","version":"1.0.0"},"tags":[],"servers":[{"url":"https://api.bird.com","description":"Production API"}],"security":[{"accessKey":[]}],"components":{"securitySchemes":{"accessKey":{"description":"Uses the Authorization header: 'AccessKey ' followed by your access key token","scheme":"AccessKey","type":"http"}},"parameters":{"pagination.param.limit":{"description":"Limits the number of results to return.","in":"query","name":"limit","schema":{"default":25,"maximum":100,"type":"integer"}},"pagination.param.pageToken":{"description":"The cursor that keeps track of the current position in the results.","in":"query","name":"pageToken","schema":{"type":"string"}},"pagination.param.reverse":{"description":"Reverses the order in which the results are returned.","in":"query","name":"reverse","schema":{"default":false,"type":"boolean"}}},"schemas":{"ReportsList":{"type":"object","title":"ReportsList","description":"A list of itemised reports","properties":{"results":{"type":"array","items":{"$ref":"#/components/schemas/Report"}}},"required":["results"]},"Report":{"type":"object","additionalProperties":false,"description":"response for a report","properties":{"id":{"type":"string","format":"uuid"},"from":{"type":"string","format":"date"},"productName":{"type":"string"},"to":{"type":"string","format":"date"},"createdAt":{"type":"string","format":"date-time"},"productId":{"type":"string","format":"uuid"},"createdBy":{"type":"string","format":"uuid"},"createdByType":{"type":"string","description":"Identifies who or what created the report. Absent on historical records created before attribution tracking was introduced.","enum":["user","api_key"]},"organizationId":{"type":"string","format":"uuid"},"rawKey":{"type":"string"},"enrichedKey":{"type":"string"},"status":{"type":"string","enum":["pending","complete"]},"metadata":{"type":"object","additionalProperties":true,"nullable":true},"reportType":{"$ref":"#/components/schemas/ReportType"}}},"ReportType":{"type":"string","title":"ReportType","enum":["itemised","aggregated"]}}},"paths":{"/organizations/{organizationId}/reports":{"get":{"operationId":"listOrganizationReports","parameters":[{"$ref":"#/components/parameters/pagination.param.limit"},{"$ref":"#/components/parameters/pagination.param.pageToken"},{"$ref":"#/components/parameters/pagination.param.reverse"}],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ReportsList"}}},"description":"OK"}},"summary":"List organization reports","tags":["ReportsList"]}}}}
```

{% tabs %}
{% tab title="Request" %}

```bash
curl -X GET "https://api.bird.com/organizations/{organizationId}/reports" \
 -H "Content-Type: application/json" \
 -H "Authorization: AccessKey abcd" 
```

{% endtab %}

{% tab title="Response (200 - OK)" %}

```bash
{
  "results": [
    {
      "id": "b657e211-a13c-58f0-85cb-508f622a502a",
      "reportType": "itemised",
      "organizationId": "organizationId",
      "productId": "productId",
      "productName": "cd03ae6e-90f8-4aa0-aba4-c1190acaf2bd",
      "createdBy": "createdBy",
      "rawKey": "rawKey.csv",
      "enrichedKey": "enrichedKey.csv.zip",
      "from": "2025-08-01",
      "to": "2025-08-31",
      "status": "complete",
      "createdAt": "2025-09-15T10:53:09.156Z",
      "metadata": null
    }
  ]
}
```

{% endtab %}
{% endtabs %}

## POST /organizations/{organizationId}/reports

> Create itemised report for organization and product

```json
{"openapi":"3.0.3","info":{"title":"Accounting","version":"1.0.0"},"tags":[],"servers":[{"url":"https://api.bird.com","description":"Production API"}],"security":[{"accessKey":[]}],"components":{"securitySchemes":{"accessKey":{"description":"Uses the Authorization header: 'AccessKey ' followed by your access key token","scheme":"AccessKey","type":"http"}},"schemas":{"CreateItemisedReport":{"type":"object","additionalProperties":false,"description":"request to generate an itemised report","required":["productId","from","to"],"properties":{"productId":{"type":"string","format":"uuid","description":"ID of the product to generate report for"},"from":{"type":"string","format":"date","description":"Start date of the report period"},"to":{"type":"string","format":"date","description":"End date of the report period"}}},"Report":{"type":"object","additionalProperties":false,"description":"response for a report","properties":{"id":{"type":"string","format":"uuid"},"from":{"type":"string","format":"date"},"productName":{"type":"string"},"to":{"type":"string","format":"date"},"createdAt":{"type":"string","format":"date-time"},"productId":{"type":"string","format":"uuid"},"createdBy":{"type":"string","format":"uuid"},"createdByType":{"type":"string","description":"Identifies who or what created the report. Absent on historical records created before attribution tracking was introduced.","enum":["user","api_key"]},"organizationId":{"type":"string","format":"uuid"},"rawKey":{"type":"string"},"enrichedKey":{"type":"string"},"status":{"type":"string","enum":["pending","complete"]},"metadata":{"type":"object","additionalProperties":true,"nullable":true},"reportType":{"$ref":"#/components/schemas/ReportType"}}},"ReportType":{"type":"string","title":"ReportType","enum":["itemised","aggregated"]},"error.detailed":{"additionalProperties":false,"description":"An error returned from the API that includes additional details about the error. The `details` property can contain any additional information about the error that may be helpful for debugging or understanding the error.\n","properties":{"code":{"description":"A unique code that identifies the error. This code can be used to programmatically identify the error.","minLength":3,"type":"string"},"details":{"additionalProperties":true,"description":"Any additional information about the error that may be helpful for debugging or understanding the error.","type":"object"},"message":{"description":"A human-readable message that describes the error.","minLength":1,"type":"string"}},"required":["code","message"],"title":"DetailedError","type":"object"}},"responses":{"requestError":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.detailed"}}},"description":"An error"}}},"paths":{"/organizations/{organizationId}/reports":{"post":{"operationId":"generateReport","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateItemisedReport"}}}},"responses":{"201":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Report"}}},"description":"Created"},"404":{"$ref":"#/components/responses/requestError"},"422":{"$ref":"#/components/responses/requestError"}},"summary":"Create itemised report for organization and product","tags":["ItemisedReport"]}}}}
```

{% tabs %}
{% tab title="Request" %}

```bash
curl -X POST "https://api.bird.com/organizations/{organizationId}/reports" \
 -H "Content-Type: application/json" \
 -H "Authorization: AccessKey abcd" \
 -d '{"productId": "9c31bfb6-d792-4a88-a0b9-904230230de5", "from": "2025-08-01", "to": "2025-08-10"}' 
```

{% endtab %}

{% tab title="Response (200 - OK)" %}

```bash
{
  "id": "150cb1d0-31f6-564b-af7f-b158b1c4b864",
  "reportType": "itemised",
  "organizationId": "organizationId",
  "productId": "9c31bfb6-d792-4a88-a0b9-904230230de5",
  "productName": "Alphanumeric",
  "createdBy": "da0a76a1-d0c7-4128-96d1-6951e6112d23",
  "rawKey": "feafd337-5d7e-42a5-a020-a4cbec8a2252/raw/feafd337-5d7e-42a5-a020-a4cbec8a2252_9c31bfb6-d792-4a88-a0b9-904230230de5_2025-08-01_2025-08-100.csv",
  "enrichedKey": "",
  "from": "2025-08-01",
  "to": "2025-08-10",
  "status": "pending",
  "createdAt": "2025-09-15T11:44:10.011Z",
  "metadata": null
}
```

{% endtab %}
{% endtabs %}

<table><thead><tr><th>ProductName</th><th>ProductId</th><th data-hidden></th></tr></thead><tbody><tr><td>ai</td><td>abd21841-400c-4d1a-8322-51929abe668c</td><td></td></tr><tr><td>alphanumeric</td><td>9c31bfb6-d792-4a88-a0b9-904230230de5</td><td></td></tr><tr><td>chat</td><td>a59a938c-ada8-4100-8834-c541798fcb48</td><td></td></tr><tr><td>contact-lookup</td><td>49f682ae-6e30-440e-b86e-7d9171d0b35a</td><td></td></tr><tr><td>contacts</td><td>82fff5bd-e147-4fcc-a8c9-760adfbea58b</td><td></td></tr><tr><td>email</td><td>2a1b4126-2a2d-4dcc-bac1-9ec7fa632394</td><td></td></tr><tr><td>facebook</td><td>9728f45c-2686-4f20-b721-3ba98d33f5c0</td><td></td></tr><tr><td>flows</td><td>b815c4f7-a3be-465d-a5e6-2e3c05a10c23</td><td></td></tr><tr><td>inbox</td><td>6f44ba37-30b7-40d8-b8b0-c613d6b06ef4</td><td></td></tr><tr><td>instagram</td><td>2c384c4d-bc72-4b5e-8ef7-2c020a6538d7</td><td></td></tr><tr><td>journeys</td><td>67f75d99-9b64-46ba-958b-ad2a7629d850</td><td></td></tr><tr><td>line</td><td>1b240f93-cf07-4edf-9866-571d008d603f</td><td></td></tr><tr><td>mms</td><td>e88a8f43-d2ff-4ae6-9bb2-f4d00ff4b1e1</td><td></td></tr><tr><td>mms10dlc</td><td>a7d6fca8-96a6-4b2a-8993-d537a5ffeb7d</td><td></td></tr><tr><td>numbers</td><td>cd03ae6e-90f8-4aa0-aba4-c1190acaf2bd</td><td></td></tr><tr><td>shortcode</td><td>9e110353-70fb-4a89-bbbc-57b785c36b20</td><td></td></tr><tr><td>sms</td><td>ba676254-3771-448e-b499-fddab7182ccb</td><td></td></tr><tr><td>sms10dlc</td><td>856bdb66-2c5a-4c02-a332-27dadffbc502</td><td></td></tr><tr><td>telegram</td><td>cd570663-b355-4f38-8766-1d25ea106bbe</td><td></td></tr><tr><td>voice</td><td>70520167-460d-41ac-bf99-04eb26517814</td><td></td></tr><tr><td>whatsapp</td><td>0177585d-27cf-45f3-b43f-fdd8cb2dcce6</td><td></td></tr></tbody></table>

## POST /organizations/{organizationId}/reports/{reportType}

> Create different report for organization and product by type

```json
{"openapi":"3.0.3","info":{"title":"Accounting","version":"1.0.0"},"tags":[],"servers":[{"url":"https://api.bird.com","description":"Production API"}],"security":[{"accessKey":[]}],"components":{"securitySchemes":{"accessKey":{"description":"Uses the Authorization header: 'AccessKey ' followed by your access key token","scheme":"AccessKey","type":"http"}},"schemas":{"CreateItemisedReport":{"type":"object","additionalProperties":false,"description":"request to generate an itemised report","required":["productId","from","to"],"properties":{"productId":{"type":"string","format":"uuid","description":"ID of the product to generate report for"},"from":{"type":"string","format":"date","description":"Start date of the report period"},"to":{"type":"string","format":"date","description":"End date of the report period"}}},"CreateAggregatedReport":{"type":"object","additionalProperties":false,"description":"request to generate an aggregated report","required":["productId","periodAggregation","from","to"],"properties":{"productId":{"type":"string","format":"uuid","description":"ID of the product to generate report for"},"units":{"type":"array","nullable":true,"items":{"type":"string"}},"periodAggregation":{"type":"string","enum":["day"],"description":"Period for aggregation"},"from":{"type":"string","format":"date","description":"Start date of the report period"},"to":{"type":"string","format":"date","description":"End date of the report period"}}},"Report":{"type":"object","additionalProperties":false,"description":"response for a report","properties":{"id":{"type":"string","format":"uuid"},"from":{"type":"string","format":"date"},"productName":{"type":"string"},"to":{"type":"string","format":"date"},"createdAt":{"type":"string","format":"date-time"},"productId":{"type":"string","format":"uuid"},"createdBy":{"type":"string","format":"uuid"},"createdByType":{"type":"string","description":"Identifies who or what created the report. Absent on historical records created before attribution tracking was introduced.","enum":["user","api_key"]},"organizationId":{"type":"string","format":"uuid"},"rawKey":{"type":"string"},"enrichedKey":{"type":"string"},"status":{"type":"string","enum":["pending","complete"]},"metadata":{"type":"object","additionalProperties":true,"nullable":true},"reportType":{"$ref":"#/components/schemas/ReportType"}}},"ReportType":{"type":"string","title":"ReportType","enum":["itemised","aggregated"]},"error.detailed":{"additionalProperties":false,"description":"An error returned from the API that includes additional details about the error. The `details` property can contain any additional information about the error that may be helpful for debugging or understanding the error.\n","properties":{"code":{"description":"A unique code that identifies the error. This code can be used to programmatically identify the error.","minLength":3,"type":"string"},"details":{"additionalProperties":true,"description":"Any additional information about the error that may be helpful for debugging or understanding the error.","type":"object"},"message":{"description":"A human-readable message that describes the error.","minLength":1,"type":"string"}},"required":["code","message"],"title":"DetailedError","type":"object"}},"responses":{"requestError":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.detailed"}}},"description":"An error"}}},"paths":{"/organizations/{organizationId}/reports/{reportType}":{"post":{"operationId":"generateReportByType","requestBody":{"content":{"application/json":{"schema":{"oneOf":[{"$ref":"#/components/schemas/CreateItemisedReport"},{"$ref":"#/components/schemas/CreateAggregatedReport"}]}}}},"responses":{"201":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Report"}}},"description":"Created"},"404":{"$ref":"#/components/responses/requestError"},"422":{"$ref":"#/components/responses/requestError"}},"summary":"Create different report for organization and product by type","tags":["Reports"]}}}}
```

{% tabs fullWidth="false" %}
{% tab title="Request" %}

```bash
curl -X POST "https://api.bird.com/organizations/{organizationId}/reports/aggregated" \
 -H "Content-Type: application/json" \
 -H "Authorization: AccessKey abcd" \
 -d '{"productId": "ba676254-3771-448e-b499-fddab7182ccb", "from": "2025-08-01", "to": "2025-08-31", "periodAggregation": "day"}'
```

{% endtab %}

{% tab title="Response (200 - OK)" %}

```bash
{
  "id": "5338f834-ffbd-557c-bbed-c33f1c785d71",
  "reportType": "aggregated",
  "organizationId": "organizationId",
  "productId": "ba676254-3771-448e-b499-fddab7182ccb",
  "productName": "SMS Channel",
  "createdBy": "da0a76a1-d0c7-4128-96d1-6951e6112d23",
  "rawKey": "acb8572c-5432-4147-8c4b-aedb238702d4/raw/agg_prd_usg_acb8572c-5432-4147-8c4b-aedb238702d4_ba676254-3771-448e-b499-fddab7182ccb__2025-08-01_2025-08-310.csv",
  "enrichedKey": "",
  "from": "2025-08-01",
  "to": "2025-08-31",
  "status": "pending",
  "createdAt": "2025-09-15T12:56:57.44Z",
  "metadata": {
    "periodAggregation": "day",
    "units": null
  }
}
```

{% endtab %}
{% endtabs %}

## GET /organizations/{organizationId}/reports/{reportId}

> Download report csv file

```json
{"openapi":"3.0.3","info":{"title":"Accounting","version":"1.0.0"},"servers":[{"url":"https://api.bird.com","description":"Production API"}],"security":[{"accessKey":[]}],"components":{"securitySchemes":{"accessKey":{"description":"Uses the Authorization header: 'AccessKey ' followed by your access key token","scheme":"AccessKey","type":"http"}},"responses":{"requestError":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/error.detailed"}}},"description":"An error"}},"schemas":{"error.detailed":{"additionalProperties":false,"description":"An error returned from the API that includes additional details about the error. The `details` property can contain any additional information about the error that may be helpful for debugging or understanding the error.\n","properties":{"code":{"description":"A unique code that identifies the error. This code can be used to programmatically identify the error.","minLength":3,"type":"string"},"details":{"additionalProperties":true,"description":"Any additional information about the error that may be helpful for debugging or understanding the error.","type":"object"},"message":{"description":"A human-readable message that describes the error.","minLength":1,"type":"string"}},"required":["code","message"],"title":"DetailedError","type":"object"}}},"paths":{"/organizations/{organizationId}/reports/{reportId}":{"get":{"operationId":"downloadReport","responses":{"200":{"content":{"application/octet-stream":{"schema":{"format":"binary","type":"string"}},"text/csv":{"schema":{"type":"string"}}},"description":"OK"},"400":{"$ref":"#/components/responses/requestError"},"404":{"$ref":"#/components/responses/requestError"}},"summary":"Download report csv file"}}}}
```

{% tabs %}
{% tab title="Request" %}

```bash
curl -X GET "https://api.bird.com/organizations/organizationId/reports/61e9b0a8-b69d-5844-8722-0f9e844af813" \
-H "Content-Type: application/json" \
-H "Authorization: AccessKey abcd" \
-o downloadreport.zip
```

{% endtab %}

{% tab title="Response (200 - OK)" %}

```bash
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.bird.com/api/reporting-api/api-reference/reports.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
